package ovh.herisson.Clyde.DTO.Msg;

/******************************************************
 * @file DiscussionDTO.java
 * @author Anthony Debucquoy
 * @scope Extension messagerie
 *
 * File to format a discussion using messageDTO 
 ******************************************************/

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import lombok.AllArgsConstructor;
import lombok.Data;
import ovh.herisson.Clyde.Tables.User;
import ovh.herisson.Clyde.Tables.Msg.Discussion;
import ovh.herisson.Clyde.DTO.Msg.MessagesDTO;

@Data
@AllArgsConstructor
public class DiscussionDTO {
	private long id;
	private String name;
	private List<User> members;
	private List<MessagesDTO> msgs;

	public static DiscussionDTO construct(Discussion d, User u){
		List<MessagesDTO> msgsdto = new ArrayList<>();
		d.getMsgs().forEach(x -> msgsdto.add(MessagesDTO.construct(x, u)));
		return new DiscussionDTO(d.getId(), d.getName(), d.getMembers(), msgsdto);
	} 
}
