package ovh.herisson.Clyde.DTO.Msg;

/******************************************************
 * @file MessagesDTO.java
 * @author Anthony Debucquoy
 * @scope Extension messagerie
 *
 * File to Format the response adding the sender field
 ******************************************************/

import lombok.AllArgsConstructor;
import lombok.Data;
import ovh.herisson.Clyde.Tables.User;
import ovh.herisson.Clyde.Tables.Msg.Message;
import java.util.Date;

@Data
@AllArgsConstructor
public class MessagesDTO {
	private long id;
	private String content; 
	private User author;
	private boolean sender;
	private Date created;
	//TODO: Attachment

	public static MessagesDTO construct(Message m, User user){
		boolean sender = false;
		if(m.getAuthor().equals(user))
			sender = true;
		return new MessagesDTO(m.getId(), m.getContent(), m.getAuthor(), sender, m.getCreated());
	}
}
