package ovh.herisson.Clyde.DTO.ScientificPublications;

/******************************************************
 * @file ResearcherDTO.java
 * @author Bartha Maxime
 * @scope Publications Scientifiques
 *
 * Researcher Format to return to front (without user password)
 ******************************************************/
import lombok.Data;
import ovh.herisson.Clyde.Services.ProtectionService;
import ovh.herisson.Clyde.Tables.ScientificPublications.Researcher;

import java.util.Map;

@Data
public class ResearcherDTO {

    private long id;
    private Map<String,Object> user;
    private String site;
    private String domain;
    private String orcidId;


    private ResearcherDTO(long id, Map<String ,Object> user, String site,String domain,String orcidId){
        this.domain = domain;
        this.orcidId = orcidId;
        this.site = site;
        this.user = user;
        this.id = id;
    }

    public static ResearcherDTO construct(Researcher researcher){
        return new ResearcherDTO(researcher.getId(), ProtectionService.userWithoutPassword(researcher.getUser()),researcher.getSite(),
                researcher.getDomain(),researcher.getOrcidId());
    }
}
