package ovh.herisson.Clyde.EndPoints;

import org.springframework.web.bind.annotation.*;
import ovh.herisson.Clyde.Repositories.*;
import ovh.herisson.Clyde.Repositories.Inscription.ExternalCurriculumRepository;
import ovh.herisson.Clyde.Repositories.Inscription.MinervalRepository;
import ovh.herisson.Clyde.Repositories.Inscription.ScholarshipRequestRepository;
import ovh.herisson.Clyde.Repositories.Inscription.UnregisterRequestRepository;
import ovh.herisson.Clyde.Services.*;
import ovh.herisson.Clyde.Services.ScientificPublications.ResearchesService;
import ovh.herisson.Clyde.Tables.*;
import ovh.herisson.Clyde.Tables.ScientificPublications.Access;
import ovh.herisson.Clyde.Tables.ScientificPublications.PaperType;
import ovh.herisson.Clyde.Tables.ScientificPublications.Research;
import ovh.herisson.Clyde.Tables.ScientificPublications.Researcher;
import ovh.herisson.Clyde.Services.Inscription.InscriptionService;
import ovh.herisson.Clyde.Tables.Inscription.ExternalCurriculum;
import ovh.herisson.Clyde.Tables.Inscription.InscriptionRequest;
import ovh.herisson.Clyde.Tables.Inscription.Minerval;
import ovh.herisson.Clyde.Tables.Inscription.ScholarshipRequest;
import ovh.herisson.Clyde.Tables.Inscription.*;

import java.util.*;

@RestController
@CrossOrigin(originPatterns = "*", allowCredentials = "true")
public class MockController {
    public final UserService userService;
    public final UserRepository userRepo;
    public final TokenRepository tokenRepo;
    public final TokenService tokenService;
    public final CurriculumCourseService CurriculumCourseService;
    public final CurriculumService curriculumService;
    public final CourseService courseService;
    public final ExternalCurriculumRepository externalCurriculumRepository;
    public final InscriptionService inscriptionService;

    public final LessonService lessonService;
    public final ScheduleService scheduleService;
    public final ScheduleLessonService scheduleLessonService;

    public final LessonRequestService lessonRequestService;
    ArrayList<User> mockUsers;

    public final ResearchesService researchesService;
    public final UserCurriculumRepository ucr;
    public final MinervalRepository minervalRepository;
    public final ScholarshipRequestRepository scholarshipRequestRepository;
    
    public final UnregisterRequestRepository uninscriptionRequestRepository;
    public MockController(UserService userService, UserRepository userRepo, TokenRepository tokenRepo, TokenService tokenService, CurriculumCourseService CurriculumCourseService, CurriculumService curriculumService, CourseService courseService, ExternalCurriculumRepository externalCurriculumRepository, ResearchesService researchesService, InscriptionService inscriptionService, UserCurriculumRepository ucr, MinervalRepository minervalRepository, ScholarshipRequestRepository scholarshipRequestRepository, UnregisterRequestRepository unregisterRequestRepository, LessonService lessonService, ScheduleService scheduleService, ScheduleLessonService scheduleLessonService, LessonRequestService lessonRequestService){
        this.userService = userService;
        this.tokenRepo = tokenRepo;
        this.userRepo = userRepo;
        this.tokenService = tokenService;
        this.CurriculumCourseService = CurriculumCourseService;
        this.curriculumService = curriculumService;
        this.courseService = courseService;
        this.externalCurriculumRepository = externalCurriculumRepository;
        this.inscriptionService = inscriptionService;
        this.researchesService = researchesService;
        this.lessonService = lessonService;
        this.scheduleService = scheduleService;
        this.scheduleLessonService = scheduleLessonService;
        this.lessonRequestService = lessonRequestService;
        this.ucr = ucr;
        this.minervalRepository = minervalRepository;
        this.scholarshipRequestRepository = scholarshipRequestRepository;
        this.uninscriptionRequestRepository = unregisterRequestRepository;
    }

    /** Saves an example of each user type by :
     * email : FooRole@FooRole.com, password : FooRole and token : FooRole
     * For example the admin as "admin@admin.com" as email and "admin" as both password and token
     * They all have silly names
     */

    @PostMapping("/mock")
    public void postMock() {


        // user part
        User herobrine = new User("brine","hero","admin@admin.com","behind","ShadowsLand",new Date(0), null,Role.Admin,"admin");
        User joe = new User("Mama","Joe","student@student.com","roundabout","England",new Date(0), null,Role.Student,"student");
        User meh = new User("Polo","Marco","secretary@secretary.com","a Box","Monaco",new Date(0), null,Role.Secretary,"secretary");
        User joke = new User("Gaillard","Corentin","teacher@teacher.com","lab","faculty",new Date(0), null,Role.Teacher,"teacher");
        User jojo = new User("Bridoux","Justin","teacher2@teacher2.com","lab","faculty",new Date(0), null,Role.Teacher,"teacher");
        User lena = new User("Louille","Lena","inscriptionService@InscriptionService.com","no","yes",new Date(0), null,Role.InscriptionService,"inscriptionService");
        User popo = new User("Smith", "Paul", "paulsmith@gmail.com", "306 rue du poulet", "belgique", new Date(0), null, Role.Student, "jesuispaulleroi");
        mockUsers = new ArrayList<>(Arrays.asList(herobrine,joe,meh,joke,lena,jojo, popo));

        userService.saveAll(mockUsers);

        ExternalCurriculum externalCurriculum = new ExternalCurriculum(null, "HEH", "Bachelier en ingénieur", "completed", 2015, 2017, null, joe);
        externalCurriculumRepository.save(externalCurriculum);

            Minerval minerval = new Minerval(joe.getRegNo(), 0, 852, 2023);
            minervalRepository.save(minerval);
            // Course / Curriculum part

        Curriculum infoBab1 = new Curriculum(1,"info", false);
        Curriculum chemistryBab1 = new Curriculum(1,"chemistry", false);
        Curriculum psychologyBab1 = new Curriculum(1,"psychology", false);
        Curriculum infoBab2 = new Curriculum(2,"info", false);
        Curriculum masterinfo1 = new Curriculum(4, "info", false);
        Curriculum masterinfo2 = new Curriculum(5, "info", false);
        Curriculum chemistryBab2 = new Curriculum(2, "chemistry", false);
        Curriculum ingebab1 = new Curriculum(1, "ingénieur", true);

        curriculumService.save(infoBab1);
        curriculumService.save(chemistryBab1);
        curriculumService.save(psychologyBab1);
        curriculumService.save(infoBab2);
        curriculumService.save(masterinfo1);
        curriculumService.save(masterinfo2);
        curriculumService.save(chemistryBab2);
        curriculumService.save(ingebab1);

        ucr.save(new UserCurriculum(joe, infoBab1, 2022, false));
        ucr.save(new UserCurriculum(joe, chemistryBab1, 2023, true));
        ucr.save(new UserCurriculum(joe, infoBab1, 2023, true));
        ucr.save(new UserCurriculum(joe, psychologyBab1, 2020, false));
        ucr.save(new UserCurriculum(popo, infoBab1, 2022, false));
        ucr.save(new UserCurriculum(popo, infoBab2, 2023, true));

        Course progra1 = new Course(5,"Programmation et algorithmique 1",joke);
        Course chemistry1 = new Course(12, "Thermochimie",jojo);
        Course psycho1 = new Course(21, "Neuroreaction of isolated brain cells",joke);
        Course commun = new Course(2, "cours commun",joke);

            courseService.save(progra1);
            courseService.save(chemistry1);
            courseService.save(psycho1);
            courseService.save(commun);

            ScholarshipRequest ssr1 = new ScholarshipRequest(joe, RequestState.Pending, 0, new Date(), "test", "test");
            scholarshipRequestRepository.save(ssr1);


        CurriculumCourseService.save(new CurriculumCourse(infoBab1,progra1));
        CurriculumCourseService.save(new CurriculumCourse(infoBab1,commun));
        CurriculumCourseService.save(new CurriculumCourse(infoBab1, psycho1));
        CurriculumCourseService.save(new CurriculumCourse(psychologyBab1,psycho1));
        CurriculumCourseService.save(new CurriculumCourse(psychologyBab1,commun));
        CurriculumCourseService.save(new CurriculumCourse(chemistryBab1, chemistry1));

            CurriculumCourseService.save(new CurriculumCourse(chemistryBab1, commun));
            CurriculumCourseService.save(new CurriculumCourse(chemistryBab1, chemistry1));


        InscriptionRequest inscriptionRequest = new InscriptionRequest("helen","prenom","non","helen@gmail.com","america",new Date(),(long) 4,RequestState.Pending,"yes.png","password", null, new Date(), RequestState.Pending, null);

            inscriptionService.save(inscriptionRequest);

            ///////////////////////////
            // extension Publications Scientifiques
            Researcher jojoResearcherAccount = new Researcher(jojo, "3363-22555-AB33-T", null, "IT");

            Researcher joResearchAccount = new Researcher(joe,"N555-321213-BED-DD",null, "Physics");


            Researcher output = researchesService.saveResearcher(jojoResearcherAccount);
            Researcher joOutput = researchesService.saveResearcher(joResearchAccount);

            Set<Researcher> coAuthor = new HashSet<>();
            coAuthor.add(joOutput);

            Research jojoResearch = new Research("Graphs : Advanced Search Algorithms", output, new Date(0),
                    PaperType.Article, "test.pdf", null, "english",
                    Access.OpenSource, "IT", "This Article's title speaks for itself \n We'll discuss about advanced Graph search Algorithms",coAuthor);
            Research restrictedResearch = new Research("just another Name", output, new Date(1111111111),
                    PaperType.Article, "restricted", null, "english",
                    Access.Restricted, "Restricted", "This Article's title speaks for itself\n We'll discuss about advanced Graph search Algorithms", new HashSet<>());

            Research privateResearch = new Research("the great Potato War", output, new Date(),
                    PaperType.Article, "private", null, "english",
                    Access.Private, "private", "This Article's title speaks for itself\n We'll discuss about advanced Graph search Algorithms",null);


            researchesService.saveResearch(restrictedResearch);
            researchesService.saveResearch(privateResearch);
            researchesService.saveResearch(jojoResearch);


        //Schedule part

        Lesson lesson_0_progra1 = new Lesson(progra1, "Mon Apr 22 2024 08:15", "Mon Apr 22 2024 10:15","rgb(0,50,100)","A0B2","Course");
        Lesson lesson_0_chemistry1 = new Lesson(chemistry1, "Wed Mar 27 2024 08:15", "Wed Mar 27 2024 09:15","rgb(100,50,0)","A0B2","TP");
        Lesson lesson_0_psycho1 = new Lesson(psycho1, "Sun Mar 24 2024 10:30 ","Sun Mar 24 2024 12:30 ","rgb(100,50,100)", "A0B2","TD");
        Lesson lesson_1_progra1 = new Lesson(progra1, "Mon Apr 02 2024 13:30", "Mon Apr 02 2024 15:30","rgb(0,50,100)","A0B2","TP");
        Lesson lesson_0_commun = new Lesson(commun, "Mon Apr 01 2024 10:30", "Mon Apr 01 2024 12:30","rgb(0,50,100)","A0B2","Course");

        LessonChangesRequest request1 = new LessonChangesRequest(joke,RequestState.Pending,null,null,null,null,2,null,1);
        LessonChangesRequest request2 = new LessonChangesRequest(joke,RequestState.Pending,"Fri Apr 19 2024 10:30 ","Fri Apr 19 2024 12:30 ",null,null,1,null,2);
        LessonChangesRequest request3 = new LessonChangesRequest(joke,RequestState.Pending,"Fri Apr 19 2024 13:30 ","Fri Apr 19 2024 15:30 ","Course",progra1,0,"rgb(27,49,100)",4);


        Schedule infoBab1Schedule = new Schedule(infoBab1);
        Schedule chemistryBab1Schedule = new Schedule(chemistryBab1);
        Schedule psychoBab1Schedule = new Schedule(psychologyBab1);


        scheduleService.save(infoBab1Schedule);
        scheduleService.save(chemistryBab1Schedule);
        scheduleService.save(psychoBab1Schedule);

        lessonService.save(lesson_0_progra1);
        lessonService.save(lesson_0_chemistry1);
        lessonService.save(lesson_0_commun);
        lessonService.save(lesson_0_psycho1);
        lessonService.save(lesson_1_progra1);

        scheduleLessonService.save(new ScheduleLesson(infoBab1Schedule,lesson_0_progra1));
        scheduleLessonService.save(new ScheduleLesson(infoBab1Schedule,lesson_1_progra1));
        scheduleLessonService.save(new ScheduleLesson(infoBab1Schedule,lesson_0_commun));

        scheduleLessonService.save(new ScheduleLesson(chemistryBab1Schedule,lesson_0_chemistry1));
        scheduleLessonService.save(new ScheduleLesson(chemistryBab1Schedule,lesson_0_commun));

        scheduleLessonService.save(new ScheduleLesson(psychoBab1Schedule,lesson_0_psycho1));
        scheduleLessonService.save(new ScheduleLesson(psychoBab1Schedule,lesson_0_commun));


        lessonRequestService.save(request1);
        lessonRequestService.save(request2);
        lessonRequestService.save(request3);

        UnregisterRequest unregisterRequest = new UnregisterRequest(RequestState.Pending, "je veux partir", new Date(), joe.getRegNo(), joe.getFirstName(), joe.getLastName(), joe.getEmail(), null);
        uninscriptionRequestRepository.save(unregisterRequest);

        externalCurriculum = new ExternalCurriculum(inscriptionRequest, "HEH", "Bachelier en informatique", "Completed", 2015, 2018, null, null);
        externalCurriculumRepository.save(externalCurriculum);
    }
}

