package ovh.herisson.Clyde.Repositories;

import jakarta.transaction.Transactional;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import ovh.herisson.Clyde.Tables.Course;
import ovh.herisson.Clyde.Tables.Curriculum;
import ovh.herisson.Clyde.Tables.CurriculumCourse;

public interface CurriculumCourseRepository extends CrudRepository<CurriculumCourse,Long> {

    @Query("select distinct cc.course from CurriculumCourse cc where cc.curriculum = ?1")
    Iterable<Course> findCoursesByCurriculum(Curriculum curriculum);

    @Query("select distinct cc.curriculum from CurriculumCourse cc where cc.course = ?1")
    Iterable<Curriculum> findCurriculumByCourses(Course course);

    @Query("select distinct cc.curriculum from  CurriculumCourse cc")
    Iterable<Curriculum> findDistinctCurriculums();

    @Modifying
    @Transactional
    @Query("delete from CurriculumCourse cc where cc.course =?1")
    void delete(Course course);

}
