package ovh.herisson.Clyde.Repositories;

/******************************************************
 * @file LessonChangesRequestRepository.java
 * @author William Karpinski
 * @scope Extension Horaire
 ******************************************************/

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import ovh.herisson.Clyde.Tables.LessonChangesRequest;
import ovh.herisson.Clyde.Tables.User;

public interface LessonChangesRequestRepository extends CrudRepository<LessonChangesRequest, Long> {
    LessonChangesRequest findById(long id);
    

    @Query("select lr from LessonChangesRequest lr where lr.user = ?1")
    Iterable<LessonChangesRequest> findOwnRequests(User user);

    @Query("select lr from LessonChangesRequest lr where lr.lessonId = ?1")
    Iterable<LessonChangesRequest> findRequestByLessonId(long id);
}
