package ovh.herisson.Clyde.Repositories;

/******************************************************
 * @file ScheduleRepository.java
 * @author William Karpinski
 * @scope Extension Horaire
 ******************************************************/

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import ovh.herisson.Clyde.Tables.Course;
import ovh.herisson.Clyde.Tables.Lesson;
import ovh.herisson.Clyde.Tables.Schedule;

public interface ScheduleRepository extends CrudRepository<Schedule,Long> {

    Schedule getById(long id);


    @Query("select distinct sl from Schedule sl where EXISTS (select c.curriculum from CurriculumCourse c where (sl.curriculum = c.curriculum) AND (c.course = ?1))")
    Iterable<Schedule> findAllLessonSchedule(Course course);
}
