package ovh.herisson.Clyde.Repositories.ScientificPublications;

/******************************************************
 * @file ResearchRepository.java
 * @author Bartha Maxime
 * @scope Publications Scientifiques
 *
 * Repository handling communication with Reseach table
 ******************************************************/
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import ovh.herisson.Clyde.Tables.ScientificPublications.Research;
import ovh.herisson.Clyde.Tables.ScientificPublications.Researcher;

import java.util.Map;

public interface ResearchRepository extends CrudRepository<Research,Long> {

    Research findById(long id);

    Iterable<Research> findByAuthor(Researcher author);

    @Query("select r from Research r where r.pdfLocation = ?1")
    Research findByPdfLocation(String url);

}
