package ovh.herisson.Clyde.Repositories.ScientificPublications;

/******************************************************
 * @file ResearcherRepository.java
 * @author Bartha Maxime
 * @scope Publications Scientifiques
 *
 * Repository handling communication with Reseacher table
 ******************************************************/
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import ovh.herisson.Clyde.Tables.ScientificPublications.Research;
import ovh.herisson.Clyde.Tables.ScientificPublications.Researcher;
import ovh.herisson.Clyde.Tables.User;

public interface ResearcherRepository extends CrudRepository<Researcher,Long> {
    Researcher findByUser(User user);

    Researcher findById(long id);

    @Query("select r from Research r where r.author = ?1")
    Iterable<Research> findAllByAuthorId(Researcher author);
}
