package ovh.herisson.Clyde.Repositories;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import ovh.herisson.Clyde.Tables.Curriculum;
import ovh.herisson.Clyde.Tables.User;
import ovh.herisson.Clyde.Tables.UserCurriculum;

import java.util.ArrayList;

public interface UserCurriculumRepository extends CrudRepository<UserCurriculum, Long> {

    @Query("select uc.curriculum from UserCurriculum uc where uc.user = ?1")
    Curriculum findByUser(User student);

    @Query("select distinct uc.user from UserCurriculum uc where uc.curriculum = ?1")
   Iterable<User> findUsersByCurriculum(Curriculum curriculum);

    ArrayList<UserCurriculum> findByUserOrderByCurriculum(User student);
    UserCurriculum findByUserAndCurriculumAndActual(User user, Curriculum curriculum, boolean actual);

    ArrayList<UserCurriculum> findByUserAndActual(User user, boolean actual);
}
