package ovh.herisson.Clyde.Services.Msg;

import org.springframework.stereotype.Service;

import lombok.AllArgsConstructor;
import ovh.herisson.Clyde.Repositories.CourseRepository;
import ovh.herisson.Clyde.Repositories.Msg.ForumRepository;
import ovh.herisson.Clyde.Repositories.Msg.TopicRepository;
import ovh.herisson.Clyde.Services.UserService;
import ovh.herisson.Clyde.Tables.Course;
import ovh.herisson.Clyde.Tables.Notification;
import ovh.herisson.Clyde.Tables.User;
import ovh.herisson.Clyde.Tables.Msg.Answer;
import ovh.herisson.Clyde.Tables.Msg.Forum;
import ovh.herisson.Clyde.Tables.Msg.Topic;

@Service
@AllArgsConstructor
public class ForumService {

	private UserService userServ;
	private CourseRepository courseRepo;
	private ForumRepository forumRepo;
	private TopicRepository topicRepo;

	public void createForum(Course c, Forum f){
		c.addForum(f);
		for (User u: f.getRegister()) {
			userServ.Notify(u, new Notification("forum.notification.forum.new", f.getName(), "/#/Forum"));
		}
		courseRepo.save(c);
	}

    public void createTopic(Forum f, Topic data) {
		f.addTopic(data);
		for (User u: f.getRegister()) {
			userServ.Notify(u, new Notification("forum.notification.topic.new", data.getSubject(), "/#/Forum"));
		}
		forumRepo.save(f);
    }

    public void answerTopic(Topic t, Answer data, User	u) {
		data.setAuthor(u);
		t.addAnswer(data);
		topicRepo.save(t);
    }
}
