package ovh.herisson.Clyde.Tables;

import jakarta.persistence.*;

import java.util.Date;

@Entity
public class ChangeCurriculumRequest {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int id;

    @ManyToOne
    @JoinColumn(name="Users")
    private User user;

    @ManyToOne
    @JoinColumn(name = "ActualCurriculum")
    private Curriculum actualCurriculum;

    @ManyToOne
    @JoinColumn(name = "DestCurriculum")
    private Curriculum destinationCurriculum;

    private Date date;

    private RequestState state;

    private RequestState teacherApprovalState;
    public ChangeCurriculumRequest(){}

    public ChangeCurriculumRequest(User user, Curriculum actualCurriculum, Curriculum destinationCurriculum, Date date, RequestState state, RequestState teacherApprovalState){
        this.user = user;
        this.actualCurriculum = actualCurriculum;
        this.destinationCurriculum = destinationCurriculum;
        this.date = date;
        this.state = state;
        this.teacherApprovalState = teacherApprovalState;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }


    public Curriculum getActualCurriculum() {
        return actualCurriculum;
    }

    public void setActualCurriculum(Curriculum actualCurriculum) {
        this.actualCurriculum = actualCurriculum;
    }

    public Curriculum getDestinationCurriculum() {
        return destinationCurriculum;
    }

    public void setDestinationCurriculum(Curriculum destinationCurriculum) {
        this.destinationCurriculum = destinationCurriculum;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public Date getDate() {
        return date;
    }

    public RequestState getState() {
        return state;
    }

    public void setState(RequestState state) {
        this.state = state;
    }

    public int getId() {
        return id;
    }

    public RequestState getTeacherApprovalState() {
        return teacherApprovalState;
    }

    public void setTeacherApprovalState(RequestState teacherApprovalState) {
        this.teacherApprovalState = teacherApprovalState;
    }
}


