package ovh.herisson.Clyde.Tables.Inscription;


import jakarta.persistence.*;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;
import ovh.herisson.Clyde.Tables.Course;
import ovh.herisson.Clyde.Tables.RequestState;
import ovh.herisson.Clyde.Tables.User;

import java.util.Date;

@Entity
public class ExemptionsRequest {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int id;

    @JoinColumn(name = "Users")
    @ManyToOne(fetch = FetchType.EAGER)
    private User user;

    @JoinColumn(name = "Course")
    @ManyToOne(fetch = FetchType.EAGER)
    private Course course;
    private String justifDocument;

    private RequestState state;

    private Date date;

    public ExemptionsRequest(User user, Course course, String justifDocument, RequestState state, Date date){
        this.user = user;
        this.course = course;
        this.justifDocument = justifDocument;
        this.state = state;
        this.date = date;
    }


    public ExemptionsRequest(){}

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Course getCourse() {
        return course;
    }

    public void setCourse(Course course) {
        this.course = course;
    }

    public String getJustifDocument() {
        return justifDocument;
    }

    public void setJustifDocument(String justifDocument) {
        this.justifDocument = justifDocument;
    }


    public RequestState getState() {
        return state;
    }

    public void setState(RequestState state) {
        this.state = state;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public int getId() {
        return id;
    }
}
