package ovh.herisson.Clyde.Tables.Inscription;


import jakarta.persistence.*;
import ovh.herisson.Clyde.Tables.User;

//This table stores a student's curriculum from another university
@Entity
public class ExternalCurriculum {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int id;

    //An external curriculum is first linked to an inscription request and when it is accepted and the user is created we link it to the user
    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name="InscriptionRequest")
    private InscriptionRequest inscriptionRequest;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name="Users")
    private User user;

    private String school;

    private String formation;

    //This string denotes the completion of the external formation or the last year completed by the student in this formation
    private String completion;

    private int startYear;
    private int endYear;
    private String justifdocUrl;

    public ExternalCurriculum(){}

    public ExternalCurriculum(InscriptionRequest ir, String school, String formation, String completion, int startYear, int endYear, String justifdocUrl,User user){
        this.inscriptionRequest = ir;
        this.school = school;
        this.formation = formation;
        this.completion = completion;
        this.startYear = startYear;
        this.endYear = endYear;
        this.justifdocUrl = justifdocUrl;
        this.user = user;
    }

    public int getId() {
        return id;
    }

    public InscriptionRequest getInscriptionRequest() {
        return inscriptionRequest;
    }

    public void setInscriptionRequest(InscriptionRequest inscriptionRequest) {
        this.inscriptionRequest = inscriptionRequest;
    }

    public String getSchool() {
        return school;
    }

    public void setSchool(String school) {
        this.school = school;
    }

    public String getFormation() {
        return formation;
    }

    public void setFormation(String formation) {
        this.formation = formation;
    }

    public String getCompletion(){
        return completion;
    }

    public void setCompletion(String completion) {
        this.completion = completion;
    }

    public int getStartYear() {
        return startYear;
    }

    public void setStartYear(int startYear) {
        this.startYear = startYear;
    }

    public int getEndYear() {
        return endYear;
    }

    public void setEndYear(int endYear) {
        this.endYear = endYear;
    }

    public void setJustifdocUrl(String justifdocUrl) {
        this.justifdocUrl = justifdocUrl;
    }

    public String getJustifdocUrl() {
        return justifdocUrl;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public User getUser() {
        return user;
    }
}
