package ovh.herisson.Clyde.Tables.Inscription;

import jakarta.persistence.*;
import ovh.herisson.Clyde.Tables.Curriculum;
import ovh.herisson.Clyde.Tables.RequestState;
import ovh.herisson.Clyde.Tables.User;

import java.util.Date;

@Entity
public class UnregisterRequest {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;
    private RequestState state;
    private String reason;
    private Date date;

    //We store these informations again so if the user is deleted we still have the informations for history
    private long regNo;

    private String firstName;

    private String lastName;

    private String email;

    //Null if the user unregister for the academic year, contains a curriculum if the user wants to unregister from a specific curriculum
    @ManyToOne
    @JoinColumn(name = "Curriculum")
    private Curriculum curriculum;

    public UnregisterRequest(RequestState state, String reason, Date date, long regNo, String firstName, String lastName, String email, Curriculum curriculum){
        this.state = state;
        this.reason = reason;
        this.date = date;
        this.regNo = regNo;
        this.firstName = firstName;
        this.lastName = lastName;
        this.email = email;
        this.curriculum = curriculum;
    }

    public UnregisterRequest(){}

    public RequestState getState() {
        return state;
    }

    public void setState(RequestState state) {
        this.state = state;
    }

    public String getReason() {
        return reason;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    public long getId() {
        return id;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public Date getDate() {
        return date;
    }

    public String getEmail() {
        return email;
    }

    public String getLastName() {
        return lastName;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public void setRegNo(long regNo) {
        this.regNo = regNo;
    }

    public long getRegNo() {
        return regNo;
    }

    public void setCurriculum(Curriculum curriculum) {
        this.curriculum = curriculum;
    }

    public Curriculum getCurriculum() {
        return curriculum;
    }

}

