package ovh.herisson.Clyde.Tables;


/******************************************************
 * @file Lesson.java
 * @author William Karpinski
 * @scope Extension Horaire
 *
 * Represent a course in a schedule
 ******************************************************/

import jakarta.persistence.*;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;


@Entity
public class Lesson {
  @Id
  @GeneratedValue(strategy = GenerationType.AUTO)
  private int lessonID;

  @ManyToOne(fetch = FetchType.EAGER)
  @OnDelete(action = OnDeleteAction.SET_NULL)
  @JoinColumn(name = "Course")
  private Course course;

  private String lessonStart;

  private String lessonEnd;
  
  private String color;
  
  private String lessonType;

  private String local;

  public Lesson(Course course,String start, String end ,String color,String local,String lessonType){
    this.lessonEnd = end;
    this.course = course;
    this.lessonStart = start;
    this.color = color;
    this.local = local;
    this.lessonType = lessonType;
  }

  public Lesson() {
  }

  public int getLessonID(){
    return lessonID;
  }

  public void setCourse(Course course) {
    this.course = course;
  }

  public Course getCourse(){
    return course;
  }

  public String getLessonStart(){
    return lessonStart;
  }

  public String getLessonEnd() {
    return lessonEnd;
  }

  public String getColor(){
    return color;
  }

  public String getLocal() {
    return local;
  }

  public String getLessonType(){
    return lessonType;
  }

  public void setLessonStart(String start){
    this.lessonStart = start;
  }

  public void setLessonEnd(String lessonEnd) {
    this.lessonEnd = lessonEnd;
  }

  public void setColor(String color){
    this.color = color;
  }

  public void setLocal(String local){
    this.local = local;
  }

  public void setLessonType(String lessonType){
    this.lessonType = lessonType;
  }
}
