package ovh.herisson.Clyde.Tables.Msg;

/******************************************************
 * @file Message.java
 * @author Anthony Debucquoy
 * @scope Extension messagerie
 *
 * Represent a message sent to a discussion
 ******************************************************/


import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import com.fasterxml.jackson.annotation.JsonIgnore;
import java.util.Date;

import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;
import jakarta.persistence.OneToOne;
import jakarta.persistence.PrePersist;
import jakarta.persistence.Temporal;
import jakarta.persistence.TemporalType;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import ovh.herisson.Clyde.Tables.User;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
public class Message {
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private long id;
	private String content; 

	@CreationTimestamp
	@Column(nullable = false)
	private Date created;

	@ManyToOne
	private User author;

	public User getAuthor() {
        return author;
    }

    @OneToOne
	private Message response;

	@ManyToOne(optional = false)
	@JsonIgnore
	private Discussion discussion;
	
}
