package ovh.herisson.Clyde.Tables;

import java.util.Date;

import org.hibernate.annotations.CreationTimestamp;

import com.fasterxml.jackson.annotation.JsonIgnore;

import jakarta.annotation.Nullable;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.ManyToOne;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@Entity
public class Notification {

	public enum Status {
		Unread, 
		Read,
		Archived
	}

	@Id
    @GeneratedValue(strategy = GenerationType.AUTO)
	private int id;
	
	private String subject;

	private String body;

	private Status status = Status.Unread;

	private String link;

	@ManyToOne
	@JsonIgnore
	private User user;

	@CreationTimestamp
	private Date creation;

	public Notification(String subject, @Nullable String body, @Nullable String link){
		this.subject = subject;
		this.body = body;
		this.link = link;
	}
}
