
package ovh.herisson.Clyde.Tables;


/******************************************************
 * @file Schedule.java
 * @author William Karpinski
 * @scope Extension Horaire
 *
 * Represent a schedule linked to a curriculum
 ******************************************************/
import jakarta.persistence.*;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;

@Entity
public class Schedule {
  @Id
  @GeneratedValue(strategy = GenerationType.AUTO)
  private int scheduleID;

  @OneToOne
  @JoinColumn(name = "Curriculum")
  @OnDelete(action = OnDeleteAction.SET_NULL)
  private Curriculum curriculum;

  public Schedule(Curriculum curriculum){
    this.curriculum = curriculum;
  }

  public Schedule() {}


  public int getScheduleID(){
  return scheduleID;
}

  public Curriculum getCurriculum(){
  return curriculum;
}

}
