package ovh.herisson.Clyde.Tables;


/******************************************************
 * @file ScheduleLesson.java
 * @author William Karpinski
 * @scope Extension Horaire
 *
 * Used to link schedules and lessons to each others
 ******************************************************/

import jakarta.persistence.*;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;


@Entity
public class ScheduleLesson{
  @Id
  @GeneratedValue(strategy = GenerationType.AUTO)
  private int id;
  
  @ManyToOne(fetch = FetchType.EAGER)
  @JoinColumn(name = "Schedule")
  @OnDelete(action = OnDeleteAction.SET_NULL)
  private Schedule schedule;


  @ManyToOne(fetch = FetchType.EAGER)
  @OnDelete(action = OnDeleteAction.SET_NULL)
  @JoinColumn(name = "Lesson")
  private Lesson lesson;

  public ScheduleLesson(Schedule schedule,Lesson lesson){
    this.schedule = schedule;
    this.lesson = lesson;
  }

  public ScheduleLesson() {
  }

  public int getID(){
    return id;
  }

  public Lesson getLesson(){
    return lesson;
  }

  public Schedule getSchedule(){
    return schedule;
  }

  public void setLesson(Lesson lesson){
    this.lesson = lesson;
  }

  public void setSchedule(Schedule schedule){
    this.schedule = schedule;
  }


} 
