package ovh.herisson.Clyde.Tables.ScientificPublications;

/******************************************************
 * @file Research.java
 * @author Maxime Bartha
 * @scope Extension Publications scientifiques
 *
 * Research entity
 ******************************************************/
import jakarta.persistence.*;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;
import java.util.Date;
import java.util.List;
import java.util.Set;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "Research")
public class Research {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    private String title;

    @ManyToOne(fetch = FetchType.EAGER)
    @OnDelete(action = OnDeleteAction.CASCADE)
    @JoinColumn(name ="Researcher")
    private Researcher author;

    @Column(nullable = false)
    private Date releaseDate;

    private PaperType paperType;

    private String pdfLocation;

    private String bibTexLocation;

    private String language;

    private Access access;

    private String domain;

    private String summary;

    private int views;

    @ManyToMany(cascade = {CascadeType.MERGE})
    @JoinTable(name = "ResearchCoAuhors",
            joinColumns = @JoinColumn(name = "research_id"),
            inverseJoinColumns = @JoinColumn(name = "researcher_id")
    )
    private Set<Researcher> coAuthors;

    public Research(String title, Researcher author, Date releaseDate, PaperType paperType,
                    String pdfLocation, String bibTexLocation, String language, Access access, String domain, String summary,Set<Researcher> coauthors){
        this.author = author;
        this.title = title;
        this.releaseDate = releaseDate;
        this.paperType = paperType;
        this.pdfLocation = pdfLocation;
        this.bibTexLocation = bibTexLocation;
        this.language = language;
        this.access = access;
        this.domain = domain;
        this.summary = summary;
        this.coAuthors = coauthors;
    }
}

