package ovh.herisson.Clyde.Tables;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;

@Entity
@Data
@AllArgsConstructor
@NoArgsConstructor
public class UserCurriculum {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int id;

    //Un étudiant peut avoir plusieurs curriculums
    @ManyToOne(fetch = FetchType.EAGER)
    @OnDelete(action = OnDeleteAction.CASCADE)
    @JoinColumn(name = "Users")
    private User user;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "Curriculum")
    @OnDelete(action = OnDeleteAction.CASCADE)
    private Curriculum curriculum;

    private int year;

    //True if the user has that curriculum at the moment false if not
    private boolean actual;

	public UserCurriculum(User u, Curriculum cu, int year, boolean actual){
		this.user = u;
		this.curriculum = cu;
		this.year = year;
		this.actual = actual;
	}
}
