package ovh.herisson.Clyde.Repositories;

import org.junit.Assert;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.test.context.TestPropertySource;
import ovh.herisson.Clyde.Tables.Role;
import ovh.herisson.Clyde.Tables.User;

import java.util.GregorianCalendar;

@DataJpaTest
@TestPropertySource(properties = {
        "spring.test.database.replace=none",
        "spring.datasource.url=jdbc:tc:postgresql:16-alpine:///db"
})
public class UserRepoTest {

    @Autowired
    UserRepository userRepo;

    @BeforeEach
    public void setup(){
        userRepo.deleteAll();
        User herobrine = new User("brine","hero","admin@admin.com","in your WalLs","ShadowsLand", new GregorianCalendar(2005, 4, 3).getTime(), null, Role.Admin,"admin");
        userRepo.save(herobrine);
    }

    @AfterEach
    public void clean(){
        userRepo.deleteAll();
    }
    @Test
    public void usertest(){
        Assert.assertEquals("brine", userRepo.findByEmail("admin@admin.com").getLastName());
        Assert.assertTrue(new GregorianCalendar(2005, 4, 3).getTime().equals(userRepo.findByEmail("admin@admin.com").getBirthDate()));
    }

}
